// **********************************************************************
//
// Copyright (c) 2001 MT Tools.
//
// All Rights Reserved
//
// MT_DORB is based in part on the product DORB,
// written by Shadrin Victor
//
// See Readme.txt for contact information
//
// **********************************************************************
unit event_admin;

interface

uses
  orb_int,event_int,orb,code_int,imr,imr_int,req_int,types,
  classes,env_int;

type

  {** org.omg.CosEventChannelAdmin._EventChannelStub }
  TEventChannel_stub = class(TORBObject,IORBObject,IEventChannel)
  protected
    function for_suppliers (): ISupplierAdmin;
    function for_consumers (): IConsumerAdmin;
    procedure _destroy();
  public
    class function narrow(const obj : IORBObject): IEventChannel;
  end;

  TEventChannelFactory_stub = class(TORBObject,IEventChannelFactory)
  protected
    function create_eventchannel(): IEventChannel;
  public
    class function narrow(const obj : IORBObject): IEventChannelFactory;
  end;

  {** org.omg.CosEventChannelAdmin._SupplierAdminStub }
  TSupplierAdmin_stub = class(TORBObject,ISupplierAdmin)
  protected
    function obtain_push_consumer():IProxyPushConsumer;
    function obtain_pull_consumer():IProxyPullConsumer;
  public
  end;

  TConsumerAdmin_stub = class(TORBObject,IConsumerAdmin)
  protected
    function obtain_push_supplier():IProxyPushSupplier;
    function obtain_pull_supplier():IProxyPullSupplier;
  public
  end;

implementation

uses
  static,stdstat,event,throw;

//******************************************************************
//  TEventChannel
//******************************************************************
class function TEventChannel_stub.narrow(const obj : IORBObject): IEventChannel;
begin
  result := TEventChannel_stub.Create;
  result.Assign(obj);
end;

procedure TEventChannel_stub._destroy();
var
  req: IStaticRequest;
begin
  req := TStaticRequest.Create(self,'destroy');
  req.Invoke;
  dorb_static_throw(req);
end;

function TEventChannel_stub.for_consumers (): IConsumerAdmin;
var
  obj : IORBObject;
  outp : IStaticAny;
  req: IStaticRequest;
begin
  result := nil;
  req := TStaticRequest.Create(self,'for_consumers');
  outp := TStaticAny.Create(stat_Object,@obj);
  req.set_result(outp);
  req.Invoke;
  dorb_static_throw(req);
  result := TConsumerAdmin_stub.Create;
  result.Assign(obj);
end;

function TEventChannel_stub.for_suppliers (): ISupplierAdmin;
var
  obj : IORBObject;
  outp : IStaticAny;
  req: IStaticRequest;
begin
  result := nil;
  req := TStaticRequest.Create(self,'for_suppliers');
  outp := TStaticAny.Create(stat_Object,@obj);
  req.set_result(outp);
  req.Invoke;
  dorb_static_throw(req);
  result := TSupplierAdmin_stub.Create;
  result.Assign(obj);
end;

//***********************************************************************
//  TEventChannelFactory
//***********************************************************************
class function TEventChannelFactory_stub.narrow(const obj : IORBObject): IEventChannelFactory;
begin
  result := TEventChannelFactory_stub.Create();
  result.Assign(obj);
end;

function TEventChannelFactory_stub.create_eventchannel(): IEventChannel;
var
  obj: IORBObject;
  outp : IStaticAny;
  req: IStaticRequest;
begin
  result := nil;
  req := TStaticRequest.Create(self,'create_eventchannel');
  outp := TStaticAny.Create(stat_Object,@obj);
  req.set_result(outp);
  req.Invoke;
  dorb_static_throw(req);
  result := TEventChannel_stub.Create;
  result.Assign(obj);
end;

//***********************************************************************
//  TSupplierAdmin
//***********************************************************************
function TSupplierAdmin_stub.obtain_push_consumer():IProxyPushConsumer;
var
  obj : IORBObject;
  outp : IStaticAny;
  req: IStaticRequest;
begin
  result := nil;
  req := TStaticRequest.Create(self,'obtain_push_consumer');
  outp := TStaticAny.Create(stat_Object,@obj);
  req.set_result(outp);
  req.Invoke;
  dorb_static_throw(req);
  result := TProxyPushConsumer_stub.Create;
  result.Assign(obj);
end;

function TSupplierAdmin_stub.obtain_pull_consumer():IProxyPullConsumer;
begin
  assert(false,'not implemented');
  result := nil;
end;

//***********************************************************************
//  TConsumerAdmin
//***********************************************************************
function TConsumerAdmin_stub.obtain_push_supplier():IProxyPushSupplier;
var
  obj : IORBObject;
  outp : IStaticAny;
  req: IStaticRequest;
begin
  result := nil;
  req := TStaticRequest.Create(self,'obtain_push_supplier');
  outp := TStaticAny.Create(stat_Object,@obj);
  req.set_result(outp);
  req.Invoke;
  dorb_static_throw(req);
  result := TProxyPushSupplier_stub.Create;
  result.Assign(obj);
end;

function TConsumerAdmin_stub.obtain_pull_supplier():IProxyPullSupplier;
var
  obj : IORBObject;
  outp : IStaticAny;
  req: IStaticRequest;
begin
  result := nil;
  req := TStaticRequest.Create(self,'obtain_pull_supplier');
  outp := TStaticAny.Create(stat_Object,@obj);
  req.set_result(outp);
  req.Invoke;
  dorb_static_throw(req);
  result := TProxyPullSupplier_stub.Create;
  result.Assign(obj);
end;


end.
